﻿using UnityEngine.UI;

namespace everlaster
{
    public class FreezeMotionSoundRelay : MVRScript
    {
        Toggle _freezeToggle;
        Toggle _freezeToggleAlt;
        JSONStorableBool _param;

        public override void Init()
        {
            _freezeToggle = SuperController.singleton.freezeAnimationToggle;
            _freezeToggleAlt = SuperController.singleton.freezeAnimationToggleAlt;

            bool isFrozen = false;
            if(_freezeToggle)
            {
                _freezeToggle.onValueChanged.AddListener(OnFreezeToggleValueChanged);
                isFrozen = _freezeToggle.isOn;
            }

            if(_freezeToggleAlt)
            {
                _freezeToggleAlt.onValueChanged.AddListener(OnFreezeToggleValueChanged);
                isFrozen = isFrozen || _freezeToggleAlt.isOn;
            }

            _param = new JSONStorableBool("Freeze Motion/Sound", isFrozen, val => SuperController.singleton.SetFreezeAnimation(val));
            RegisterBool(_param);
            CreateToggle(_param);
        }

        void OnFreezeToggleValueChanged(bool isFrozen) => _param.valNoCallback = isFrozen;

        void OnDestroy()
        {
            if(_freezeToggle == null || _freezeToggleAlt == null)
            {
                return;
            }

            _freezeToggle.onValueChanged.RemoveListener(OnFreezeToggleValueChanged);
            _freezeToggleAlt.onValueChanged.RemoveListener(OnFreezeToggleValueChanged);
        }
    }
}
